



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>用SAX和PULL进行XML文件的解析与生成</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">用SAX和PULL进行XML文件的解析与生成</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 21:24:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>XML解析有传统的dom方法还有Jsoup，SAX,PULL等，这里讲的是比较省内存的SAX和PULL方法。Android中极力推荐用PULL的方式来解析，我个人觉得pull确实比较简单，但其内部的逻辑性不是很分明。所以今天做了个类来将其中的多个步骤进行了分割，以后直接拿来用即可。</p>
<p><strong>1.SAX:</strong></p>
<p>首先先讲解SAX中各个方法的作用：</p>
<p>我们以这个不规则的xml语句做例子：</p>
<p><strong>&lt;abc:kale&nbsp;sex=m&nbsp;age=21&gt;jack&lt;/abc:kale&gt;</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201410/121021457336521.jpg" /></p>
<p>startDocument：开始解析一个xml文件时触发</p>
<p>endDocument：这个xml文件被解析完毕时触发</p>
<p>startElement：开始解析xml文件中的一个标签时触发，这里可以得到标签名和其中的各个属性值。</p>
<p>如：从&lt;person age = 12 sex = f/&gt;会得到标签名：【person】和属性值：【age = 12 sex = f】</p>
<p>endElement：结束解析一个标签时触发</p>
<p>characters：解析这个标签内部的内容时触发，这里可以得到这个标签子节点中的内容。</p>
<p>如：从&lt;name&gt;jack&lt;name&gt;中得到【jack】</p>
<p>下面是实现代码：</p>
<p>1.首先建立一个SAX对象，然后进行解析工作。这里会要自己建立一个ContentHandler的子类</p>
<div>
<pre class="prettyprint linenums">/**<br />
     * 通过sax进行解析<br />
     * @param str<br />
     */<br />
    public void sax(String str) {<br />
        //下面是固定的写法<br />
        SAXParserFactory factory = SAXParserFactory.newInstance();<br />
        XMLReader reader;<br />
        try {<br />
            //得到xmlReader对象<br />
            reader = factory.newSAXParser().getXMLReader();<br />
            //设置内容处理器<br />
           <strong> reader.setContentHandler(new</strong><strong> MyContentHandler());</strong><br />
            reader.parse(new InputSource(new StringReader(str)));

        } catch (SAXException | ParserConfigurationException | IOException e) {<br />
            // TODO 自动生成的 catch 块<br />
            e.printStackTrace();<br />
        }<br />
    }</pre>
</div>
<p>MyContentHandler.java 这个类就是来处理事务的，里面有各种回调方法</p>
<div>
<pre class="prettyprint linenums">package com.kale.xml;

import org.xml.sax.Attributes;<br />
import org.xml.sax.SAXException;<br />
import org.xml.sax.helpers.DefaultHandler;

/**<br />
 * @author:Jack Tony<br />
 * @tips  :举个极端的例子：&lt;input type="hidden" name="UserType"&gt;kale&lt;/input&gt;<br />
 *     startElement中可以得到的是：type="hidden" name="UserType"<br />
 *     characters中得到的是：kale<br />
 * @date  :2014-10-11<br />
 */<br />
public class MyContentHandler extends DefaultHandler{<br />
    //当前正在解析的标签名<br />
    private String currentTag;

    /*<br />
     * 开始解析这个xml文件的时候触发<br />
     */<br />
    @Override<br />
    public void startDocument() throws SAXException {<br />
        System.out.println("开始解析这个文件了");<br />
    }

    /*<br />
     * 结束解析这个xml文件的时候触发<br />
     */<br />
    @Override<br />
    public void endDocument() throws SAXException {<br />
        System.out.println("文件解析结束");<br />
    }

    /*<br />
     * 开始解析每个元素的时候触发<br />
     * &lt;person age = 12 sex = f/&gt;<br />
     * &lt;kale:name&gt;jack&lt;kale:name&gt;<br />
     * 1.uri：当前正在解析的元素的命名空间<br />
     * 2.localName：不带前缀的这个元素的名字&mdash;&mdash;&gt;name<br />
     * 3.qName：带前缀的这个元素命&mdash;&mdash;&gt;kale:name<br />
     * 4.attributes：得到的元素中的属性&mdash;&mdash;&gt;age=12 set=f<br />
     */<br />
    @Override<br />
    public void startElement(String uri, String localName, String qName,<br />
            Attributes attributes) throws SAXException {<br />
        //举例：&lt;input type="hidden" name="UserType" id="UserType" value="1"&gt;<br />
        currentTag = localName;//input<br />
        System.out.println("&mdash;&mdash;&mdash;&mdash;开始解析"+qName+"这个标签了&mdash;&mdash;&mdash;&mdash;");

        for (int i = 0; i &lt; attributes.getLength(); i++) {<br />
            String name = attributes.getLocalName(i);//第一次是：type<br />
            String value = attributes.getValue(i);//第一次是：hidden<br />
            System.out.println(name + " = " + value);<br />
        }

    }

    /* （非 Javadoc）<br />
     * @see org.xml.sax.helpers.DefaultHandler#endElement(java.lang.String, java.lang.String, java.lang.String)<br />
     * 停止解析这个元素的时候触发<br />
     */<br />
    @Override<br />
    public void endElement(String uri, String localName, String qName)<br />
            throws SAXException {<br />
        // TODO 自动生成的方法存根<br />
        super.endElement(uri, localName, qName);<br />
        System.out.println("&mdash;&mdash;&mdash;&mdash;-解析"+qName+"标签结束&mdash;&mdash;&mdash;&mdash;");<br />
    }

    /*<br />
     * 得到元素中的内容，比如下面的jack<br />
     * &lt;name&gt;jack&lt;name&gt;<br />
     */<br />
    @Override<br />
    public void characters(char[] ch, int start, int length)<br />
            throws SAXException {<br />
        //举例：&lt;name&gt;jack&lt;name&gt;<br />
        if (currentTag.equals("name")) {<br />
            System.out.println("name = " + new String(ch,start,length));//会输出jack<br />
        }<br />
        if (currentTag.equals("age")) {<br />
            System.out.println("age = " + new String(ch,start,length));//会输出21<br />
        }<br />
    }<br />
}</pre>
</div>
<p>贴上测试样本（由于xml文件可能是不规范的，所以处理时要考虑异常）：</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
&lt;namespace xmlns:abc="http://schemas.android.com/apk/res/android"&gt;<br />
    &lt;form id="form1" name="form1" method="post" action="ok" style="margin: 0; padding: 0;" &gt;<br />
        &lt;input type="hidden" name="UserType" id="12" value="1"/&gt;<br />
        &lt;abc:name&gt;jack&lt;/abc:name&gt;<br />
        &lt;abc:age&gt;21&lt;/abc:age&gt;<br />
    &lt;/form&gt;<br />
&lt;/namespace&gt;</pre>
</div>
<p>测试结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201410/121031174683691.jpg" /></p>
<p><strong>2.PULL</strong></p>
<p>其实PULL中就一个重要的方法XmlPullParser.next();，正因如此才让其变得简单很多。PULL的特点是运行到什么状态是没有回调方法的，它进行某个处理状态时，会改变一个状态变量，通过getEventType()就可以来判断当前是处于什么状态了。</p>
<p>推荐浏览：http://384444165.iteye.com/blog/1521332</p>
<p>但正因为内部逻辑需要开发者来处理，所以变得结构不是很清晰。我这里通过一个类来将其转换为SAX的框架，以后只需要复写这些方法便可以直接进行操作了。至于运行到哪一步，看方法名酒明白了。同样还是之前的那幅图：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201410/121036451245592.jpg" /></p>
<p>这里面的方法的作用也是和SAX一样的。下面是使用的代码：</p>
<p>1.建立这个类的对象，执行操作</p>
<div>
<pre class="prettyprint linenums">    /**<br />
     * 通过pull进行解析<br />
     * @param str<br />
     */<br />
    public void pull(String str) {<br />
        XmlPullParser parser = Xml.newPullParser();<br />
        InputStream in = new ByteArrayInputStream(str.getBytes());<br />
        try {<br />
            parser.setInput(in,"utf-8");<br />
            MyXmlPullParserTask task = new MyXmlPullParserTask(parser);<br />
            task.execute();//开始解析文件<br />
        } catch (XmlPullParserException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }</pre>
</div>
<p>2.进行解析处理</p>
<p>MyXmlPullParserTask.java</p>
<p>我通过前面的switch-case语句将处理的状态进行了分割，这些状态可以完全类比到SAX中。这样便于理解！</p>
<div>
<pre class="prettyprint linenums">package com.kale.xml;

import java.io.IOException;

import org.xmlpull.v1.XmlPullParser;<br />
import org.xmlpull.v1.XmlPullParserException;

public class MyXmlPullParserTask {<br />
    /**<br />
     * 当前正在解析的标签名,类似于sax中的localName<br />
     * 可以得到&lt;abc:kale sex=m age=21&gt;jack&lt;/abc:kale&gt;中【kale】<br />
     */<br />
    private String currentTag;

    /**<br />
     * 当前正在解析的标签名的前缀，sax中的qName=前缀+当前标签名<br />
     * 可以得到&lt;abc:kale sex=m age=21&gt;jack&lt;/abc:kale&gt;中【abc】<br />
     */<br />
    private String currentPrefix;

    /**<br />
     * 当前正在解析的标签的命名空间，类似于sax中的uri<br />
     * 得到<br />
     *     &lt;namespace xmlns:abc="http://schemas.android.com/apk/res/android"&gt;<br />
     *     &lt;abc:kale sex=m age=21&gt;jack&lt;/abc:kale&gt;<br />
     * 中的【http://schemas.android.com/apk/res/android】<br />
     */<br />
    private String currentNamespace;

    private XmlPullParser parser;

    public MyXmlPullParserTask(XmlPullParser parser) {<br />
        this.parser = parser;<br />
    }

    /**<br />
     * 开始解析的方法，这里已经写好了，尽量不要该这里的代码。<br />
     */<br />
    public void execute() {<br />
        try {<br />
            // 得到当前状态的标识代码<br />
            int eventCode = parser.getEventType();<br />
            // 如果当前状态不是文档结束，那么就继续循环<br />
            boolean flag = true;<br />
            while (flag) {<br />
                // 当前解析元素的标签，不带前缀<br />
                currentTag = parser.getName();<br />
                currentNamespace = parser.getNamespace();<br />
                currentPrefix = parser.getPrefix();

                switch (eventCode) {<br />
                case XmlPullParser.START_DOCUMENT:<br />
                    startDocument();<br />
                    break;<br />
                case XmlPullParser.END_DOCUMENT:<br />
                    endDocument();<br />
                    flag = false;// 到文档末尾了，结束循环<br />
                    break;<br />
                case XmlPullParser.START_TAG:<br />
                    startElement(parser);<br />
                    characters(parser);<br />
                    break;<br />
                case XmlPullParser.END_TAG:<br />
                    endElement(parser);<br />
                    break;<br />
                default:<br />
                    break;<br />
                }<br />
                eventCode = parser.next();<br />
            }<br />
        } catch (XmlPullParserException | IOException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }

    /**<br />
     * 开始解析文件时触发的方法<br />
     */<br />
    public void startDocument() {<br />
        System.out.println("开始解析这个文件了");<br />
    }

    /**<br />
     * 结束解析这个xml文件的时候触发<br />
     */<br />
    public void endDocument() {<br />
        System.out.println("该文件解析完成");<br />
    }

    /**<br />
     * 开始解析某个标签时触发<br />
     * 可以得到&lt;abc:kale sex=m age=21&gt;jack&lt;/abc:kale&gt;中【sex=m age=21】部分<br />
     * @param parser<br />
     */<br />
    public void startElement(XmlPullParser parser) {<br />
        System.out.println("&mdash;&mdash;&mdash;&mdash;开始解析"  + currentPrefix +":"+ currentTag + "这个标签了&mdash;&mdash;&mdash;&mdash;");

        for (int i = 0; i &lt; parser.getAttributeCount(); i++) {<br />
            String name = parser.getAttributeName(i);<br />
            String value = parser.getAttributeValue(i);<br />
            System.out.println(name + " = " + value);<br />
        }<br />
    }

    /**<br />
     * 结束解析某个标签时触发<br />
     * 遇到/&gt;时表示一个标签解析完成，而遇到&lt;/xxx&gt;不会触发<br />
     * @param parser<br />
     */<br />
    public void endElement(XmlPullParser parser) {<br />
        System.out.println("&mdash;&mdash;&mdash;&mdash;解析" + currentPrefix +":"+ currentTag + "标签结束&mdash;&mdash;&mdash;&mdash;");<br />
    }

    /**<br />
     * 解析标签中内容时触发<br />
     * 得到&lt;name&gt;jack&lt;/name&gt;中【jack】的部分<br />
     * @param parser<br />
     * @throws XmlPullParserException<br />
     * @throws IOException<br />
     */<br />
    public void characters(XmlPullParser parser) throws XmlPullParserException, IOException {<br />
        if (currentTag.equals("name")) {<br />
            System.out.println("name = " + parser.nextText());// 会输出jack<br />
        } else if (currentTag.equals("age")) {<br />
            System.out.println("age = " + parser.nextText());// 会输出21<br />
        }<br />
    }<br />
}</pre>
</div>
<p>测试样本：</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
&lt;namespace xmlns:abc="http://schemas.android.com/apk/res/android"&gt;<br />
    &lt;form id="form1" name="form1" method="post" action="ok" style="margin: 0; padding: 0;" &gt;<br />
        &lt;input type="hidden" name="UserType" id="12" value="1"/&gt;<br />
        &lt;abc:name&gt;jack&lt;/abc:name&gt;<br />
        &lt;abc:age&gt;21&lt;/abc:age&gt;<br />
    &lt;/form&gt;<br />
&lt;/namespace&gt;</pre>
</div>
<p>测试结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201410/121039422499337.jpg" /></p>
<p><strong>3.XML文件的生成</strong></p>
<p>生成是用简单的pull来做的，没啥技术含量，就是用代码来写xml，最后放到sd卡中</p>
<div>
<pre class="prettyprint linenums">    /**<br />
     * 建立一个xml文件<br />
     */<br />
    public void creatXML() {<br />
        XmlSerializer serializer = Xml.newSerializer();<br />
        File file = new File(Environment.getExternalStorageDirectory(),"sharpandroid.xml");<br />
        FileOutputStream fos = null;<br />
        try {<br />
            fos = new FileOutputStream(file);<br />
            serializer.setOutput(fos, "UTF-8");

            serializer.startDocument("UTF-8", true);<br />
            //命名空间+标签名，命名空间可以=null<br />
            serializer.startTag(null, "namespace");<br />
            serializer.attribute("http://schemas.android.com/apk/res/android", "abc", "egf");

            serializer.startTag(null, "persons");<br />
            for (int i = 0; i &lt; 2; i++) {<br />
                serializer.startTag(null, "person");<br />
                serializer.attribute(null, "id", i+1+"");<br />
                serializer.attribute(null, "age", i+10+"");

                serializer.startTag(null, "name");<br />
                serializer.text("jack");<br />
                serializer.endTag(null, "name");

                serializer.endTag(null, "person");<br />
            }<br />
            serializer.endTag(null, "persons");<br />
            serializer.endTag(null, "namespace");<br />
            serializer.endDocument();

        } catch (IllegalArgumentException | IllegalStateException | IOException e) {<br />
            // TODO 自动生成的 catch 块<br />
            e.printStackTrace();<br />
        }<br />
        finally {<br />
            try {<br />
                fos.flush();<br />
                fos.close();<br />
            } catch (IOException e) {<br />
                // TODO 自动生成的 catch 块<br />
                e.printStackTrace();<br />
            }

        }<br />
    }</pre>
</div>
<p>测试结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201410/121041393748753.png" /></p>
<p>全部activity中的代码</p>
<div>
<pre class="prettyprint linenums">package com.kale.xml;

import java.io.BufferedReader;<br />
import java.io.ByteArrayInputStream;<br />
import java.io.File;<br />
import java.io.FileOutputStream;<br />
import java.io.IOException;<br />
import java.io.InputStream;<br />
import java.io.InputStreamReader;<br />
import java.io.StringReader;

import javax.xml.parsers.ParserConfigurationException;<br />
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.InputSource;<br />
import org.xml.sax.SAXException;<br />
import org.xml.sax.XMLReader;<br />
import org.xmlpull.v1.XmlPullParser;<br />
import org.xmlpull.v1.XmlPullParserException;<br />
import org.xmlpull.v1.XmlSerializer;

import android.app.Activity;<br />
import android.os.Bundle;<br />
import android.os.Environment;<br />
import android.util.Xml;<br />
import android.view.View;<br />
import android.widget.Toast;

public class MainActivity extends Activity {

    @Override<br />
    protected void onCreate(Bundle savedInstanceState) {<br />
        super.onCreate(savedInstanceState);<br />
        setContentView(R.layout.activity_main);<br />
        creatXML();<br />
        Toast.makeText(this, "xml文件建立成功，在SD卡根目录下sharpandroid.xml", 0).show();<br />
    }

    public void buttonListener(View v) {<br />
        //从assets文件夹中得到test.xml文件的内容<br />
        String str = getFromAssets("test.xml");<br />
        switch (v.getId()) {<br />
        case R.id.sax_button:<br />
            //通过sax进行文件的解析<br />
            sax(str);<br />
            break;<br />
        case R.id.pull_button:<br />
            //通过pull来解析文件<br />
            pull(str);<br />
            break;

        default:<br />
            break;<br />
        }<br />
    }

    /**<br />
     * 通过sax进行解析<br />
     * @param str<br />
     */<br />
    public void sax(String str) {<br />
        //下面是固定的写法<br />
        SAXParserFactory factory = SAXParserFactory.newInstance();<br />
        XMLReader reader;<br />
        try {<br />
            //得到xmlReader对象<br />
            reader = factory.newSAXParser().getXMLReader();<br />
            //设置内容处理器<br />
            reader.setContentHandler(new MyContentHandler());<br />
            reader.parse(new InputSource(new StringReader(str)));

        } catch (SAXException | ParserConfigurationException | IOException e) {<br />
            // TODO 自动生成的 catch 块<br />
            e.printStackTrace();<br />
        }<br />
    }

    /**<br />
     * 通过pull进行解析<br />
     * @param str<br />
     */<br />
    public void pull(String str) {<br />
        XmlPullParser parser = Xml.newPullParser();<br />
        InputStream in = new ByteArrayInputStream(str.getBytes());<br />
        try {<br />
            parser.setInput(in,"utf-8");<br />
            MyXmlPullParserTask task = new MyXmlPullParserTask(parser);<br />
            task.execute();//开始解析文件<br />
        } catch (XmlPullParserException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }

      /**<br />
     * @param fileName<br />
     * @return assets中文件的字符串<br />
     */<br />
    public String getFromAssets(String fileName){<br />
          String result="";<br />
          try {<br />
              InputStreamReader inputReader = new InputStreamReader( getResources().getAssets().open(fileName) );<br />
              BufferedReader bufReader = new BufferedReader(inputReader);<br />
              String line="";<br />
              while((line = bufReader.readLine()) != null) {<br />
                  result += line;<br />
              }<br />
          } catch (Exception e) {<br />
              e.printStackTrace();<br />
          }<br />
          return result;<br />
      }

    /**<br />
     * 建立一个xml文件<br />
     */<br />
    public void creatXML() {<br />
        XmlSerializer serializer = Xml.newSerializer();<br />
        File file = new File(Environment.getExternalStorageDirectory(),"sharpandroid.xml");<br />
        FileOutputStream fos = null;<br />
        try {<br />
            fos = new FileOutputStream(file);<br />
            serializer.setOutput(fos, "UTF-8");

            serializer.startDocument("UTF-8", true);<br />
            //命名空间+标签名，命名空间可以=null<br />
            serializer.startTag(null, "namespace");<br />
            serializer.attribute("http://schemas.android.com/apk/res/android", "abc", "egf");

            serializer.startTag(null, "persons");<br />
            for (int i = 0; i &lt; 2; i++) {<br />
                serializer.startTag(null, "person");<br />
                serializer.attribute(null, "id", i+1+"");<br />
                serializer.attribute(null, "age", i+10+"");

                serializer.startTag(null, "name");<br />
                serializer.text("jack");<br />
                serializer.endTag(null, "name");

                serializer.endTag(null, "person");<br />
            }<br />
            serializer.endTag(null, "persons");<br />
            serializer.endTag(null, "namespace");<br />
            serializer.endDocument();

        } catch (IllegalArgumentException | IllegalStateException | IOException e) {<br />
            // TODO 自动生成的 catch 块<br />
            e.printStackTrace();<br />
        }<br />
        finally {<br />
            try {<br />
                fos.flush();<br />
                fos.close();<br />
            } catch (IOException e) {<br />
                // TODO 自动生成的 catch 块<br />
                e.printStackTrace();<br />
            }

        }<br />
    }

}</pre>
</div>
<p>布局文件：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201410/121043585625742.jpg" /></p>
<div>
<pre class="prettyprint linenums">&lt;RelativeLayout xmlns:android="http://schemas.android.com/apk/res/android"<br />
    xmlns:tools="http://schemas.android.com/tools"<br />
    android:layout_width="match_parent"<br />
    android:layout_height="match_parent"<br />
    tools:context="${relativePackage}.${activityClass}" &gt;

    &lt;Button<br />
        android:id="@+id/sax_button"<br />
        android:layout_width="wrap_content"<br />
        android:layout_height="wrap_content"<br />
        android:layout_alignParentLeft="true"<br />
        android:layout_alignParentTop="true"<br />
        android:text="通过SAX来解析"<br />
        android:onClick="buttonListener"/&gt;

    &lt;Button<br />
        android:id="@+id/pull_button"<br />
        android:layout_width="wrap_content"<br />
        android:layout_height="wrap_content"<br />
        android:layout_alignParentRight="true"<br />
        android:layout_alignParentTop="true"<br />
        android:text="通过PULL来解析"<br />
        android:onClick="buttonListener"/&gt;

&lt;/RelativeLayout&gt;</pre>
</div>
<p>源码下载：<strong><a href="http://download.csdn.net/detail/shark0017/8028375" rel="external nofollow noreferrer">http://download.csdn.net/detail/shark0017/8028375</a></strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyg1wgq.html">w3svc服务启动 不了，错误 1068&colon;依赖服务或组件无法启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvkzjo9.html">关于 C&num; 调用 JavaWebservice服务&comma;版本不一致的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qypldxq.html">Maven使用笔记（四）pom&period;xml配置详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdewwd09.html">虚拟机IP设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdylxe8.html">Eclipse设置、调优、使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok514p9.html">基于Ascensor&period;js全屏切换页面插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v4xy48.html">Spark Streaming揭秘 Day16 数据清理机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x7vxz8.html">codeforces 629D  树状数组&plus;LIS</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0xw70q.html">【JSF框架】 是一种标准</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnvol6q.html">Web开发需要关注的技术细节</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kv6d29.html">JVM保证线程安全</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyxoyk9.html">thinkphp5基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzkl1l8.html">python学习day8 文件操作&lpar;深度学习&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyy2xv9.html">【python】版本35 正则-非库-爬虫-读写xlw文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r50g3dq.html">005&lowbar;tcp&sol;ip监控</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw3vj78.html">《Unity3D 实战核心技术详解》书中关于矩阵的错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw6dnd8.html">ajax请求案例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvx26x8.html">R语言 让纵坐标的标签显示为横向</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r67ln9.html">PostgreSQL的下载安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvey42x9.html">WCF-ServiceEndpoint的监听地址与监听模式</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8o4k01eq.html">Build OpenJDK9 on macOS Sierra</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kwl3vq.html">EFCore CodeFirst 适配数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwldmz39.html">hdu 5007  水题 （2014西安网赛A题）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em1vre9.html">001 SpringMVC的helloWorld程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vz132q.html">Parcel极速零配置Web应用打包工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2n12v8.html">开发自己的山寨Android注解框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvdp7mq.html">内存缓存 ehcache</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7emp6x9.html">yum与apt命令比较，yum安装出现No package vim available解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pzykjq.html">centos7安装rvm</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vkzl0q.html">理解JVM模型</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
